VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EmailCheck"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Const TIMEOUT = 10
Public Enum EmailVerifiedConst
    vfabNotVerified = 0
    vfabInvalidDomain = 1
    vfabValidDomain = 2
    vfabValidDomainInvalidAccount = 3
    vfabValidDomainValidAccount = 4
End Enum

Dim WithEvents oWinsock As Winsock
Attribute oWinsock.VB_VarHelpID = -1
Dim strEmailAddr As String, intTimeOut As Integer
Dim strUserName As String, strDomainName As String
Dim intStep As Integer, blnOk As Boolean
Dim strEmailName As String, strRealName As String
Dim intPos As Integer, strCommand As String
Dim dblTimeOut As Double, intResult As EmailVerifiedConst
Dim intSmtpTimeOut As Integer
Dim strSmtpServers As Variant
Dim strLog As String, strDNSServer As String

Private Sub Class_Initialize()
intSmtpTimeOut = TIMEOUT
Set oWinsock = Form1.Winsock1
End Sub

Public Sub Clear()
If oWinsock.State = sckConnected Then
    oWinsock.Close
End If
strLog = ""
strEmailName = ""
strRealName = ""
strEmailAddr = ""
strSmtpServers = ""
intSmtpTimeOut = TIMEOUT
intResult = vfabNotVerified
End Sub

Public Property Get Result() As EmailVerifiedConst
Result = intResult
End Property

Public Property Get SmtpTimeOut() As Integer
SmtpTimeOut = intSmtpTimeOut
End Property

Public Property Let SmtpTimeOut(ByVal intNewValue As Integer)
intSmtpTimeOut = intNewValue
End Property

Public Property Get RealName() As String
RealName = strRealName
End Property

Public Property Get EmailAddr() As String
EmailAddr = strEmailAddr
End Property

Public Property Let EmailAddr(ByVal strNewValue As String)
strEmailAddr = strNewValue
End Property

Public Property Get DomainName() As String
DomainName = strDomainName
End Property

Public Property Get UserName() As String
UserName = strUserName
End Property

Public Property Get Log(Optional blnHTML As Boolean) As String
If blnHTML Then
    Log = strTran(strLog, vbCrLf, "<br>" & vbCrLf)
Else
    Log = strLog
End If
End Property

Public Property Get SmptServers() As String
SmptServers = strSmtpServers
End Property

Public Property Let SmptServers(ByVal strNewValue As String)
strSmtpServers = strNewValue
End Property

Public Property Let DnsServer(ByVal strNewValue As String)
strSmtpServers = strNewValue
End Property

Public Sub CheckDomain()
Dim oDNS As New SIMPLEDNSRESOLVERLib.SimpleDNSClient

intPos = InStr(strEmailAddr, "@")
If intPos = 0 Then
    Err.Raise vbObjectError + 699, , "Please specify a valid E-mail address"
    Exit Sub
End If
strUserName = Left(strEmailAddr, intPos - 1)
strDomainName = Mid(strEmailAddr, intPos + 1)
If strDNSServer <> "" Then
    oDNS.ServerAddresses = strDNSServer
End If
oDNS.Separator = ", "
intResult = EmailVerifiedConst.vfabInvalidDomain
strLog = strLog & "DNS   -> Query: MX records for " & strDomainName & vbCrLf
On Error Resume Next
oDNS.GetEmailServers strDomainName, strSmtpServers
If Err <> 0 Then
    Err.Raise vbObjectError + 698, , Err.Description
End If
strLog = strLog & "DNS   <- " & strSmtpServers & vbCrLf
If strSmtpServers <> "" Then
    intResult = EmailVerifiedConst.vfabValidDomain
End If
End Sub

Public Sub CheckUserName()
Dim strHost As String, i As Integer, intOldStep As Integer

i = 1
strRealName = ""
strEmailName = ""
Do While True
    strHost = Trim(LTrim(Token(strSmtpServers, ",", i)))
    If strHost = "" Then
        Exit Do
    End If
    If InStr(strHost, strDomainName) > 0 Then 'Ha senso provare via SMTP solo per gli account del dominio stesso...

        With oWinsock
            .Protocol = sckTCPProtocol
            .RemoteHost = strHost
            .RemotePort = 25
            .Connect
            dblTimeOut = intSmtpTimeOut
            intStep = 1
            Do While .State <> sckConnected
                Sleep 100
                DoEvents
                dblTimeOut = dblTimeOut - 0.1
            Loop
            If .State <> sckConnected Then
                Exit Sub
            End If
            Do While True
                Select Case intStep
                Case 1
'                    SendData " "
                Case 2
                    SendData "VRFY " & strUserName & "@" & strDomainName & vbCrLf
                Case 3
                    .Close
                    Exit Do
                Case 4
                    SendData "HELO somewhere.com" & vbCrLf
                Case 5
                    SendData "MAIL FROM: someone@somewhere.com" & vbCrLf
                Case 6
                    SendData "RCPT TO: " & strUserName & "@" & strDomainName & vbCrLf
                End Select
                intOldStep = intStep
                dblTimeOut = intSmtpTimeOut
                Do While intStep = intOldStep And dblTimeOut > 0
                    Sleep 100
                    DoEvents
                    dblTimeOut = dblTimeOut - 0.1
                Loop
                If dblTimeOut < 0 Then
                    intStep = 0
                    Exit Do
                End If
            Loop
            If intStep = 3 Then
                Exit Do
            End If
            .Close
            Sleep 1000
        End With
    End If
    i = i + 1
Loop
'Select Case intResult
'Case -2
'    MsgBox "Invalid domain name (" & strDomainName & ")", vbCritical
'Case -1
'    MsgBox "Valid Domain name (" & strDomainName & ") - Unable to verify account (" & strUserName & ")", vbInformation
'Case 0
'    MsgBox "Valid Domain name (" & strDomainName & ") - Invalid account (" & strEmailName & ")", vbCritical
'Case 1
'    MsgBox "Valid Domain name (" & strDomainName & ") - Valid Email name (" & strEmailName & ") - Real name: " & strRealName, vbInformation
'End Select
End Sub

Private Sub SendData(strCommand As String)
oWinsock.SendData strCommand
strLog = strLog & "SMTP -> " & strCommand
End Sub

Private Sub oWinsock_DataArrival(ByVal bytesTotal As Long)
Dim strResponse As String

oWinsock.GetData strResponse
strLog = strLog & "SMTP <- " & strResponse & vbCrLf

'Patch 1
If Left(strResponse, 4) = "252 " And InStr(strResponse, "<") > 0 And InStr(strResponse, ">") > 0 Then
    strResponse = "250 " & Mid(strResponse, 5)
End If

Select Case Left(strResponse, 3)
Case "220" 'Prompt del server
    intStep = 2
Case "250" 'Replay
    Select Case intStep
    Case 2 'Replay a VRFY
        intResult = EmailVerifiedConst.vfabValidDomainValidAccount
        intStep = 3
        intPos = InStr(strResponse, "<")
        If intPos > 5 Then
            strRealName = Trim(Mid(strResponse, 5, intPos - 1 - 5))
        Else
            strRealName = "???"
        End If
        strEmailName = Trim(strTran(strTran(Mid(strResponse, intPos + 1), vbCr), vbLf))
        intPos = InStr(strEmailName, ">")
        If intPos > 0 Then
            strEmailName = Left(strEmailName, intPos - 1)
        Else
            If InStr(UCase(strResponse), "OK") > 0 Then
                strEmailName = strUserName
            End If
        End If
    Case 4 'Replay a HELO
        intStep = 5
    Case 5 'Replay a MAIL FROM:
        intStep = 6
    Case 6 'Replay a RCPT TO:
        intStep = 3
        If InStr(UCase(strResponse), "OK") > 0 Then
            strRealName = "???"
            strEmailName = strUserName & "@" & strDomainName
            intResult = EmailVerifiedConst.vfabValidDomainValidAccount
        Else
            intResult = EmailVerifiedConst.vfabValidDomainInvalidAccount
        End If
    End Select
Case "550"
    If InStr(UCase(strResponse), "UNKNOWN") > 0 Or _
    InStr(UCase(strResponse), "INACTIVE") > 0 Then
        intResult = EmailVerifiedConst.vfabValidDomainInvalidAccount
        intStep = 3
    End If
Case Else '"500" 'Command unrecognized
    If intStep = 2 Then
        intStep = 4 'Fallito il VRFY, proviamo con MAIL... "
    Else
        intStep = 3 'Niente da fare, usciamo...
    End If
End Select
End Sub

Private Function strTran(strInput As String, strMarker As String, Optional strSost As String) As String
Dim lngPos As Long, lngMarkerLen As Long, lngSostLen As Long
lngMarkerLen = Len(strMarker)
lngSostLen = Len(strSost)
lngPos = 1
Do While True
    lngPos = InStr(lngPos, strInput, strMarker)
    If lngPos = 0 Then Exit Do
    strInput = Left(strInput, lngPos - 1) & strSost & Mid(strInput, lngPos + Len(strMarker))
    lngPos = lngPos - lngMarkerLen + lngSostLen + 1
Loop
strTran = strInput
End Function

Private Function Token(ByVal strInput As String, strSep As String, ByVal intOccur As Integer) As String
Dim i As Long, intLen As Integer ' , strInput As String
strInput = strSep & strInput & strSep
intLen = Len(strSep)
For i = 1 To Len(strInput)
    If Mid(strInput, i, intLen) = strSep Then intOccur = intOccur - 1
    If intOccur = 0 Then
        Token = Mid(strInput, i + 1)
        If Len(Token) > 0 Then
            i = InStr(Token, strSep)
            If i > 1 Then
                Token = Left(Token, i - 1)
            End If
        End If
        Exit For
    End If
Next i
End Function

